package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID             = "uid"
	NAME            = "name"
	INFO            = "info"
	TYPE            = "type"
	LEVEL           = "level"
	STATUS          = "status"
	TITLE           = "title"
	CONTENT         = "content"
	USER_UID        = "user_uid"
	USER_ROLE       = "user_role"
	USER_STORY_ROLE = "user_story_role"
	STORY_UID       = "story_uid"
	STORY_NAME      = "story_name"
	STORY_TYPE      = "story_type"
	PLAN_UID        = "plan_uid"
	PLAN_STATUS     = "plan_status"
	ISSUE_COUNT     = "issue_count"
	TASK_COUNT      = "task_count"
	CASE_COUNT      = "case_count"
	ISSUE_UID       = "issue_uid"
	ISSUE_TYPE      = "issue_type"
	ISSUE_STATUS    = "issue_status"
	TASK_UID        = "task_uid"
	TASK_STATUS     = "task_status"
	CASE_STATUS     = "case_status"
	MARKET_UID      = "market_uid"
	BEGIN_TIME      = "begin_time"
	END_TIME        = "end_time"
)

type UserStory struct {
	db.ModelUserPlace
	StoryUID string `gorm:"type:char(32);index"`
}
type Story struct {
	db.ModelPlace
	CompanyUID string `gorm:"type:char(32);index"`
}
type Plan struct {
	db.ModelContent
	StoryUID    string `gorm:"type:char(32);index"`
	Status      uint8  `gorm:"default:0"`
	IssueCount  int    `gorm:"default:0"`
	TaskCount   int    `gorm:"default:0"`
	CaseCount   int    `gorm:"default:0"`
	BeginTime   db.Time
	EndTime     db.Time
	ProcessTime db.Time
	FinishTime  db.Time
}
type Issue struct {
	Common
	TaskCount   int `gorm:"default:0"`
	RejectTime  db.Time
	ApproveTime db.Time
}
type Task struct {
	Common
	IssueUID  string `gorm:"type:char(32);index"`
	CaseCount int    `gorm:"default:0"`
	BeginTime db.Time
	EndTime   db.Time
}
type Case struct {
	Common
	TaskUID string `gorm:"type:char(32);index"`
}

func init() { db.CmdModels("", &UserStory{}, &Story{}, &Plan{}, &Issue{}, &Task{}, &Case{}) }

type Common struct {
	db.ModelContent
	StoryUID    string `gorm:"type:char(32);index:idx_story"`
	PlanUID     string `gorm:"type:char(32);index:idx_story"`
	Type        uint8  `gorm:"default:0"`
	Level       uint8  `gorm:"default:2"`
	Status      uint8  `gorm:"default:0"`
	ProcessTime db.Time
	FinishTime  db.Time
}
